<?php

  class data_playlists extends data
  {

    function pl_last_downloads($n = null)
    { return $this->dp_playlist
      ( " ORDER BY #--download_urls.date_publication DESC"
       .(isset($n) ? " LIMIT ".$n : "")
      );
    }

    function pl_rand_downloads($n = null)
    { return $this->dp_playlist
      ( " ORDER BY RAND()"
       .(isset($n) ? " LIMIT ".$n : "")
      );
    }

    function pl_artiste_downloads($id_artiste, $album = null)
    { return $this->dp_playlist
      (  (isset($album) ? " AND #--downloads.id_album=".$album : "")
        ." AND #--artistes.id=".$id_artiste
        ." ORDER BY #--downloads.ordre ASC"
       .(isset($n) ? " LIMIT ".$n : "")
      );
    }

    function dp_playlist($_sql)
    { $playlist = array();
      try
      { $sql =
         "SELECT *"
        .", YEAR(date_updated) as year_updated"
        .", IF(MONTH(date_updated) > 9, MONTH(date_updated), CONCAT('0', MONTH(date_updated))) as month_updated"
        .", IF(DAYOFMONTH(date_updated) > 9, DAYOFMONTH(date_updated), CONCAT('0', DAYOFMONTH(date_updated))) as day_updated"
        ." FROM ( SELECT"
        ."  distinct(#--download_urls.id_download)"
        .", #--download_urls.id as id_download_url"
        .", #--download_urls.url"
        .", #--downloads.nom as titre"
        .", #--downloads.style"
        .", #--formats.content_type"
        .", #--artistes.nom as auteur"
        .", #--artistes.id as id_auteur"
        .", #--licences.id as id_licence"
        .", #--licences.nom as licence"
        .", #--licences.lien as licence_url"
        .", #--downloads.date_creation as date_created"
        .", #--download_urls.date_publication as date_updated"
        ." FROM"
        ."  #--download_urls"
        .", #--formats"
        .", #--downloads"
        .", #--artistes"
        .", #--licences"
        ." WHERE #--download_urls.id_format=#--formats.id"
        ." AND #--download_urls.id_download=#--downloads.id"
        ." AND #--downloads.id_artiste=#--artistes.id"
        ." AND #--downloads.id_licence=#--licences.id"
        ." AND actif=1"
        .$_sql
        .") t";
        $rst = $this->sql->query($sql);
        while($v_rst = $this->sql->fetch_assoc($rst))
        { $playlist[$v_rst["id_download"]] = $v_rst;
          $playlist[$v_rst["id_download"]]["urls"] = array();
          $u_query =
           "SELECT #--download_urls.*, #--formats.nom as format"
          ." FROM #--download_urls, #--formats"
          ." WHERE id_download=".$v_rst["id_download"]
          ." AND #--download_urls.id_format=#--formats.id";
          $u_rst = $this->sql->query($u_query);
          while($v_u_rst = $this->sql->fetch_assoc($u_rst))
          { $playlist[$v_rst["id_download"]]["urls"][$v_u_rst["id"]] = $v_u_rst;
            $playlist[$v_rst["id_download"]]["compteur"] += $v_u_rst["compteur"];
            if($v_u_rst["format"] === "mp3")
            { $playlist[$v_rst["id_download"]]["mp3_id_url"] = $v_u_rst["id"];
              $playlist[$v_rst["id_download"]]["mp3_url"] = $v_u_rst["url"];
            }
          }
          $this->sql->free_result($u_rst);
        }
      }
      catch(Exception $_e) { $playlist = false; }
      return $playlist;
    }

  }

?>